#include "XPac.h"

// These routines are to decrypt the ROMs for 
// Pac-Man Plus.

unsigned char PacPlusDecrypt1(unsigned char e)
{
	return e;
}

unsigned char PacPlusDecrypt2(unsigned char e)
{
	unsigned char d;

	d  = ((~e) & 0x80) >> 5;
	d |= ((~e) & 0x40) << 1;
	d |= (e & 0x20) >> 2;
	d |= (e & 0x10) >> 4;
	d |= (e & 0x08) << 2;
	d |= ((~e) & 0x04) << 2;
	d |= (e & 0x02) << 5;
	d |= ((~e) & 0x01) << 1;

	return d;
}

unsigned char PacPlusDecrypt3(unsigned char e)
{
	unsigned char d;

	d  = (e & 0x80) >> 2;
	d |= ((~e) & 0x40) >> 2;
	d |= ((~e) & 0x20) >> 5;
	d |= (e & 0x10) >> 1;
	d |= ((~e) & 0x08) << 3;
	d |= ((~e) & 0x04) >> 0;
	d |= (e & 0x02) >> 0;
	d |= ((~e) & 0x01) << 7;

	return d;
}

unsigned char PacPlusDecrypt4(unsigned char e)
{
	unsigned char d;

	d  = (e & 0x80) >> 0;
	d |= (e & 0x40) >> 0;
	d |= ((~e) & 0x20) >> 0;
	d |= (e & 0x10) >> 0;
	d |= ((~e) & 0x08) >> 0;
	d |= (e & 0x04) >> 0;
	d |= (e & 0x02) >> 0;
	d |= (e & 0x01) >> 0;

	return d;
}

unsigned char PacPlusDecrypt5(unsigned char e)
{
	unsigned char d;

	d  = ((~e) & 0x80) >> 5;
	d |= ((~e) & 0x40) << 1;
	d |= ((~e) & 0x20) >> 0;
	d |= (e & 0x10) >> 4;
	d |= ((~e) & 0x08) >> 0;
	d |= ((~e) & 0x04) << 2;
	d |= (e & 0x02) << 5;
	d |= ((~e) & 0x01) << 1;

	return d;
}

unsigned char PacPlusDecrypt6(unsigned char e)
{
	unsigned char d;

	d  = ((~e) & 0x80) >> 4;
	d |= ((~e) & 0x40) >> 2;
	d |= ((~e) & 0x20) >> 5;
	d |= (e & 0x10) << 1;
	d |= ((~e) & 0x08) << 3;
	d |= ((~e) & 0x04) >> 0;
	d |= (e & 0x02) >> 0;
	d |= ((~e) & 0x01) << 7;

	return d;
}

unsigned char PacPlusDecrypt(int addr, unsigned char e)
{
	unsigned int method = 1;

	switch (addr & 0x2A5)
	{
		case 0x001:
		case 0x201:
		case 0x005:
		case 0x025:
		case 0x080:
		case 0x084:
		case 0x085:
		case 0x0A5:
		case 0x2A5:
		case 0x200:
		case 0x221:
		case 0x2A1:
			method = 2;
			break;
		case 0x004:
		case 0x204:
		case 0x020:
		case 0x220:
		case 0x024:
		case 0x224:
		case 0x0A0:
		case 0x2A0:
		case 0x0A4:
		case 0x2A4:
		case 0x281:
		case 0x285:
			method = 3;
			break;
	}

	if ((addr & 0x800) == 0x800)
		method = method + 3;

	switch (method)
	{
		case 1:	return PacPlusDecrypt1(e);
		case 2: return PacPlusDecrypt2(e);
		case 3:	return PacPlusDecrypt3(e);
		case 4: return PacPlusDecrypt4(e);
		case 5:	return PacPlusDecrypt5(e);
		case 6: return PacPlusDecrypt6(e);
	}

	return 0;
}


