/***************************************************************************

  Mini-Pac Copyright (C) 1999 by Michael Balfour.  All Rights Reserved.


  Pac-Man Copyright (C) 1980 by Namco, Ltd.  All Rights Reserved.


  Multi-Z80 32 Bit emulator 
  Copyright (C) 1996-1999 Neil Bradley, All rights reserved
  Author      : Neil Bradley (neil@synthcom.com)
  Distribution: ftp://ftp.synthcom.com/pub/emulators/cpu/makez80.zip (latest)

 ***************************************************************************/

// INCLUDES ///////////////////////////////////////////////////////////////////

#include "XPac.h"
#include "..\resource.h"

extern UCHAR *emu_mem;

MiniPac            *miniPac;      // Mini-Pac primary game engine
int					RunorNot = 0;
extern int			GameSelected = 0;
extern int			DipDefault[10] = {-1, 
									  -1,
									  -1,
									  -1,
									  -1,
									  -1,
									  -1,
									  -1,
									  -1,
									  -1};
HINSTANCE saveInstance;
HWND savehwnd;
HWND g_hWndDlg2 = NULL;
HWND g_hWndDlg3 = NULL;

LRESULT CALLBACK
XPacOptionsDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK
AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK
DipSwitchDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

int DipList[11] = {IDC_DIPCOMBO1,
					 IDC_DIPCOMBO2,
					 IDC_DIPCOMBO3,
					 IDC_DIPCOMBO4,
					 IDC_DIPCOMBO5,
					 IDC_DIPCOMBO6,
					 IDC_DIPCOMBO7,
					 IDC_DIPCOMBO8,
					 IDC_DIPCOMBO9,
					 IDC_DIPCOMBO10};

int DipName[11] = {IDC_DIPNAME1,
                   IDC_DIPNAME2,
				   IDC_DIPNAME3,
				   IDC_DIPNAME4,
				   IDC_DIPNAME5,
				   IDC_DIPNAME6,
				   IDC_DIPNAME7,
				   IDC_DIPNAME8,
				   IDC_DIPNAME9,
				   IDC_DIPNAME10};

WORD JoyX;
WORD JoyY;

// DEFINES ////////////////////////////////////////////////////////////////////

#define WINDOW_CLASS_NAME "WINDOW_CLASS" // this is the name of the window class

// WINDOWS CALLBACK FUNCTION //////////////////////////////////////////////////		             

// this is the main message handler of the system
LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{

	PAINTSTRUCT ps;			// used to hold the paint info
	//HRESULT hr;

	// what is the message?

	switch(msg)
	{	
		case WM_CREATE:
			if(joySetCapture(hwnd, JOYSTICKID1, 100, FALSE))
				return -1;
			return(0);
			break;
		case MM_JOY1MOVE:
			JoyX = LOWORD(lparam) >> 11;
			JoyY = HIWORD(lparam) >> 11;
			
			if ((INT) JoyX <= 12)
			{
				emu_mem[0x5000] &= 0xFD;
				emu_mem[0x5000] |= 0x01;
				emu_mem[0x5000] |= 0x04;
				emu_mem[0x5000] |= 0x08;
				break;
			}
			if ((INT) JoyX >= 20)
			{
				emu_mem[0x5000] &= 0xFB;
				emu_mem[0x5000] |= 0x01;
				emu_mem[0x5000] |= 0x02;
				emu_mem[0x5000] |= 0x08;
				break;
			}
			if ((INT) JoyY <= 12)
			{
				emu_mem[0x5000] &= 0xFE;
				emu_mem[0x5000] |= 0x02;
				emu_mem[0x5000] |= 0x04;
				emu_mem[0x5000] |= 0x08;
				break;
			}
			if ((INT) JoyY >=20)
			{
				emu_mem[0x5000] &= 0xF7;
				emu_mem[0x5000] |= 0x01;
				emu_mem[0x5000] |= 0x02;
				emu_mem[0x5000] |= 0x04;
				break;
			}
			return(0);
			break;
		case WM_PAINT:
		{
			// this message occurs when your window needs repainting
			BeginPaint(hwnd,&ps);	 
			EndPaint(hwnd,&ps);
		
			return(0);
   		} break;

        case WM_KEYDOWN:
            // Handle any non-accelerated key commands
        	switch (wparam)
        	{
				case VK_UP:
					emu_mem[0x5000] &= 0xFE;	break;
				case VK_LEFT:
					emu_mem[0x5000] &= 0xFD;	break;
				case VK_RIGHT:
					emu_mem[0x5000] &= 0xFB;	break;
				case VK_DOWN:
					emu_mem[0x5000] &= 0xF7;	break;
				case '1':
					emu_mem[0x5040] &= 0xDF;	break;
				case '2':
					emu_mem[0x5040] &= 0xBF;	break;
				case '3':
					emu_mem[0x5000] &= 0xDF;	break;
				case 'U':
					miniPac->Unthrottle();      break;
				case 'R':
					miniPac->Reset();           break;
            	case VK_ESCAPE:
					PostMessage(hwnd, WM_CLOSE, 0, 0);
                    return 0L;
        	}
        	break;

        case WM_KEYUP:
            // Handle any non-accelerated key commands
        	switch (wparam)
        	{
				case VK_UP:
					emu_mem[0x5000] |= 0x01;	break;
				case VK_LEFT:
					emu_mem[0x5000] |= 0x02;	break;
				case VK_RIGHT:
					emu_mem[0x5000] |= 0x04;	break;
				case VK_DOWN:
					emu_mem[0x5000] |= 0x08;	break;
				case '1':
					emu_mem[0x5040] |= 0x20;	break;
				case '2':
					emu_mem[0x5040] |= 0x40;	break;
				case '3':
					emu_mem[0x5000] |= 0x20;	break;
				case 'U':
					miniPac->Throttle();        break;
        	}
        	break;

		case WM_DESTROY:
		{
			// this message is sent when your window is destroyed
			PostQuitMessage(0);
			return(0);
		} break;

		default:break;

    } // end switch

	// let windows process any messages that we didn't take care of 
	return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPSTR sCmdLine,
					int nCmdShow)
{

	
	WNDCLASSEX		winclass;	// this holds the windows class info
	HWND			hwnd;		// this holds the handle of our new window
	MSG				msg;		// this holds a generic message

	// DirectInputCreate needs the instance handle!

	if (!hPrevInstance)
    {
	    // first fill in the window class stucture

	    winclass.cbSize			= sizeof(WNDCLASSEX);
	    winclass.style			= CS_DBLCLKS | CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	    winclass.lpfnWndProc	= WindowProc;
	    winclass.cbClsExtra		= 0;
	    winclass.cbWndExtra		= 0;
	    winclass.hInstance		= hInstance;
	    winclass.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_PACMAN));
	    winclass.hIconSm		= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_PACMAN));
	    winclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	    winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	    winclass.lpszMenuName	= NULL;
	    winclass.lpszClassName	= WINDOW_CLASS_NAME;
	
	    // register the window class
	    if (!RegisterClassEx(&winclass))
		    return(0);
    }

	// create the window
	if (!(hwnd = CreateWindowEx(WS_EX_TOPMOST,
								WINDOW_CLASS_NAME,					// class
								"XPac",            				// title
								WS_VISIBLE | WS_POPUP,
						 		0,0,								// x,y
								GetSystemMetrics(SM_CXSCREEN),
								GetSystemMetrics(SM_CYSCREEN),				
								NULL,								// parent
								NULL,								// menu
								hInstance,							// instance
								NULL)))								// creation parms
		return(0);

	// Display dialog box
    
	HWND g_hWndDlg;
	
	saveInstance = hInstance;
	savehwnd = hwnd;
	g_hWndDlg = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_OPTIONS),
                             hwnd, (DLGPROC) XPacOptionsDlgProc);

	ShowWindow(hwnd,SW_HIDE);
	
	while (TRUE)
    {
        if (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
        {
            if (!GetMessage(&msg, NULL, 0, 0))
                break;
            // If the dialog is showing, translate messages for it since it's
            // a modeless dialog.
            if (g_hWndDlg == (HWND )NULL || !IsDialogMessage(g_hWndDlg, &msg))
            {
                // Translate and dispatch the message
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
        }
        else
			if (RunorNot != 0)
            {
				
                break;
            }
            else
			
                // Make sure we go to sleep if we have nothing else to do
                WaitMessage();
    }

	if (RunorNot != 1)
    {
		// This means they hit cancel.
        return 0;
    }

	
	DestroyWindow(g_hWndDlg);
	if (g_hWndDlg2 != NULL)
	{
		DestroyWindow(g_hWndDlg2);
		g_hWndDlg2 = NULL;
	}
	
	ShowWindow(hwnd,nCmdShow);
	UpdateWindow(hwnd);
	SetFocus(hwnd);
	// hide the mouse cursor
	ShowCursor(false);

    try
    {
	    // initialize game
        miniPac = new MiniPac(hwnd);
    }
    catch (char *e)
    {
    	ShowCursor(true);
        MessageBox(hwnd,e,"Error",MB_OK);
		DestroyWindow(hwnd);
        return 0;
    }


	// enter main event loop
	while(1)
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{ 
			// test if this is a quit
			if (msg.message == WM_QUIT)
				break;
	
			// translate any accelerator keys
			TranslateMessage(&msg);

			// send the message to the window proc
			DispatchMessage(&msg);
		} // end if
		else
		{
            miniPac->ExecuteFrame();
		} // end else

    } // end while

	// shutdown game
    delete miniPac;

	// clean up

	DestroyWindow(hwnd);

    // return to Windows

	
	return(msg.wParam);

} // end WinMain


LRESULT CALLBACK
XPacOptionsDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    BOOL    fProcessed = TRUE;


    switch (uMsg)
    {
		// As long as RunorNot = 0, the loop will 
		// continue and the dialog will be displayed.
		// -1 = stop the program
		// 1 = start emulation

		case WM_INITDIALOG:
            fProcessed = TRUE;
            /*
			// Init the droplist of driver names
            for (i=0; i < gDriverCnt; i++)
                SendDlgItemMessage(hwndDlg, IDC_COMBO_DRIVERS, CB_ADDSTRING, 0, (LONG) Drivers[i].szDescription );
            SendDlgItemMessage(hwndDlg, IDC_COMBO_DRIVERS, CB_SETCURSEL, 0, 0 );
			*/
            break;
        case WM_COMMAND:
            switch (LOWORD( wParam ))
            {
                case IDOK:
                    // Set the default driver GUID to the one the user has selected
                    /*
					i = SendDlgItemMessage(hwndDlg, IDC_COMBO_DRIVERS, CB_GETCURSEL, 0, 0 );
                    
					gpSelectedDriverGUID = Drivers[i].pGUID;
					*/
					if (g_hWndDlg2 == NULL)
					{
						DestroyWindow(g_hWndDlg2);
						g_hWndDlg2 = NULL;
					}

					if (GameSelected != 0)
					{
						RunorNot = 1;
						EndDialog( hwndDlg, TRUE );
					}
					fProcessed = TRUE;
					break;

                case IDC_RADIO1:
					GameSelected = NAMCOPAC;
					fProcessed = TRUE;
					break;
				case IDC_RADIO2:
					GameSelected = MIDWAYPAC;
					fProcessed = TRUE;
					break;
				case IDC_RADIO3:
					GameSelected = MSPACMAN;
					fProcessed = TRUE;
					break;
				case IDC_RADIO4:
					GameSelected = PACPLUS;
					fProcessed = TRUE;
					break;
				case IDC_RADIO5:
					GameSelected = PACMOD;
					fProcessed = TRUE;
					break;
				case IDC_RADIO6:
					GameSelected = PACMANJP;
					fProcessed = TRUE;
					break;
				case IDC_RADIO7:
					GameSelected = HANGLY;
					fProcessed = TRUE;
					break;
				case IDC_RADIO8:
					GameSelected = PUCKMAN;
					fProcessed = TRUE;
					break;
				case IDC_RADIO9:
					GameSelected = MSPACATK;
					fProcessed = TRUE;
					break;
				case IDC_RADIO10:
					GameSelected = THEGLOB;
					fProcessed = TRUE;
					break;
				case IDC_RADIO11:
					GameSelected = PIRANHA;
					fProcessed = TRUE;
					break;
				case IDC_RADIO12:
					GameSelected = CRUSH;
					fProcessed = TRUE;
					break;
				case IDC_RADIO13:
					GameSelected = PONPOKO;
					fProcessed = TRUE;
					break;
				case IDCANCEL:
					RunorNot = -1;
                    EndDialog( hwndDlg, TRUE );
                    fProcessed = TRUE;
                    break;
				case ID_HELP_ABOUT:
					if (g_hWndDlg2 == NULL)
					{
						g_hWndDlg2 = CreateDialog(saveInstance, MAKEINTRESOURCE(IDD_ABOUT),
                             savehwnd, (DLGPROC) AboutDlgProc);
					}
					ShowWindow(g_hWndDlg2,SW_SHOW);
					fProcessed = TRUE;
					break;
				case ID_OPTIONS_DIPSWITCHES:
					if (GameSelected != 0)
					{
						if (g_hWndDlg3 != NULL)
							DestroyWindow(g_hWndDlg3);
						g_hWndDlg3 = CreateDialog(saveInstance, MAKEINTRESOURCE(IDD_DIPSWITCHES),
							savehwnd, (DLGPROC) DipSwitchDlgProc);
						ShowWindow(g_hWndDlg3,SW_SHOW);
					}
					fProcessed = TRUE;
					break;
				case ID_FILE_EXIT:
					RunorNot = -1;
                    EndDialog( hwndDlg, TRUE );
					fProcessed = TRUE;
                    break;
				
				
            }
		default:
            fProcessed = FALSE;
            //break;
    }
    return (fProcessed);
}

LRESULT CALLBACK
AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    BOOL    fProcessed = TRUE;

    switch (uMsg)
    {
		// As long as RunorNot = 0, the loop will 
		// continue and the dialog will be displayed.
		// -1 = stop the program
		// 1 = start emulation

		case WM_INITDIALOG:
			fProcessed = TRUE;
            //PlaySound(MAKEINTRESOURCE(IDR_XPAC),NULL,SND_RESOURCE);
            break;
        case WM_LBUTTONDOWN:
			EndDialog( hwndDlg, TRUE );
			fProcessed = TRUE;
			break;
		case WM_RBUTTONDOWN:
			PlaySound(MAKEINTRESOURCE(IDR_XPAC),NULL,SND_RESOURCE);
			EndDialog( hwndDlg, TRUE );
			fProcessed = TRUE;
			break;				
		default:
            fProcessed = FALSE;
            //break;
    }
    return (fProcessed);
}
	
LRESULT CALLBACK
DipSwitchDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    BOOL    fProcessed = TRUE;
	//int i;
	static char *Bleah = "Yo!";
	DipSwitch *DipLook;
	int CurrentSwitch = -1;

	switch (uMsg)
    {
		
		case WM_INITDIALOG:
			switch (GameSelected)
			{
				case MSPACMAN:
				case MSPACATK:
					DipLook = MsPacSwitches;
					break;
				case PACPLUS:
				case PACMOD:
				case PACMANJP:
				case HANGLY:
				case PUCKMAN:
				case MIDWAYPAC:
				case THEGLOB:
				case PIRANHA:
				case NAMCOPAC:
					DipLook = NamcoPacSwitches;
					break;
				case CRUSH:
					DipLook = CrushSwitches;
					break;
				//case PONPOKO:

					 
			}
			int i;
			// Clear the variables and names
			for (i=0; i<10; i++)
			{
				SETNAME(DipName[i], ""); 
			}
			if (DipDefault[0] == -1)
			{
				for (i=0; i<10; i++)
					DipDefault[i] = 0;
			}
			// Add each DIP switch setting and name to the dialog
			while (DipLook->mask != -2)
			{
				switch (DipLook->mask)
				{
					case 1: // DIPNAME
						CurrentSwitch++;
						if (DipDefault[CurrentSwitch] == 0)
							DipDefault[CurrentSwitch] = DipLook->defaultvalue;
						SETNAME(DipName[CurrentSwitch], DipLook->name);
						break;
					case 0: // DIPSETTING
						ADDCOMBOITEM(DipList[CurrentSwitch], DipLook->name);
						break;
				}
				DipLook++;
			}
			// Add unused stuff to the remaining switches
			// Figure out how to just hide them.
			for (i=CurrentSwitch+1; i<10; i++)
				ADDCOMBOITEM(DipList[i], "UNUSED");
			// Set default DIP switch settings
			for (i=0; i<10; i++)
			{
				if (DipDefault[i] != 0)
				{
					SETCOMBO(DipList[i], DipDefault[i] - 1);	
				}
				else
					SETCOMBO(DipList[i], 0);
			}
			fProcessed = TRUE;
            break;
        case WM_COMMAND:
			switch (LOWORD( wParam ))
            {
                case IDOK:
					for (i=0; i<10; i++)
						DipDefault[i] = 1 + SendDlgItemMessage(hwndDlg, DipList[i], CB_GETCURSEL, 0, 0 );
                    EndDialog( hwndDlg, TRUE );
					fProcessed = TRUE;
					break;
				case IDCANCEL:
				    EndDialog( hwndDlg, TRUE );
					fProcessed = TRUE;
					break;
			}
		default:
			fProcessed = FALSE;
            break;
    }
    return (fProcessed);
}

